#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use MIME::Entity;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my %argument = ();
my %attachment = ();
foreach my $a (@ARGV) {
    if ($a =~ s/^Content-([^=]+)=//) {
	$attachment{$1} = $a;
    } elsif ($a =~ s/^([^=]+)=//) {
        $argument{$1} = $a;
    } else {
        die "invalid argument [$a]\n";
    }
}
my @required = qw(AffectedCI AssignmentGroup Contact Description Impact Title Urgency);
my @missing = ();
my $misscount = 0;
foreach my $r (@required) {
    if (! exists $argument{$r}) {
        $misscount += 1;
        push(@missing, $r);
    }
}
die "$misscount required args missing:\n\t" . join(' ', sort(@missing)) . "\n"
    if ($misscount);

my @xargs = ();
foreach my $k (keys %argument) {
    push(@xargs, SOAP::Data->name($k => $argument{$k}));
}

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/IncidentManagement.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"Create"'; } );
if (length(keys(%attachment))) {
    my $att1 = SOAP::Data->name('attachment' => '')->type('');
    $att1->attr->{'Content-ID'} = $attachment{'Path'};
    my $attarg =
	SOAP::Data->name('attachments' => \SOAP::Data->value($att1)->type(''));
    push(@xargs, $attarg);
    $attachment{'Content-ID'} = $attachment{'Path'};
    my $attent = build MIME::Entity %attachment;
    $soap->parts([$attent]);
}
my $x = SOAP::Data->value(@xargs);

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => \$x)->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('CreateIncident', $model);

soapfault($som);
soapstatus($som);
soapdata($som, '//CreateIncidentResponse/messages', 1);
soapdata($som, '//CreateIncidentResponse/model', 0);
